// -*- C++ -*-
/*!
 * @file  ClueAnalyzer.h for PW
 * @brief ClueAnalyzer Component
 * @date  $Date$
 *
 * $Id$
 */

#ifndef CLUEANALYZER_H
#define CLUEANALYZER_H

#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>
#include <rtm/idl/BasicDataTypeSkel.h>

#include "ClueDataSplit.h"

// Service implementation headers
// <rtc-template block="service_impl_h">

// </rtc-template>

// Service Consumer stub headers
// <rtc-template block="consumer_stub_h">

// </rtc-template>

using namespace RTC;

class ClueAnalyzer
  : public RTC::DataFlowComponentBase
{
 public:
  ClueAnalyzer(RTC::Manager* manager);
  ~ClueAnalyzer();

  // <rtc-template block="public_attribute">
  ClueDataSplit IsClueDataSplit;
  
  // </rtc-template>

  // <rtc-template block="public_operation">
  void operation_1(void);
  void operation_2(void);
  
  // </rtc-template>

  // The initialize action (on CREATED->ALIVE transition)
  // formaer rtc_init_entry() 
  virtual RTC::ReturnCode_t onInitialize();

  // The finalize action (on ALIVE->END transition)
  // formaer rtc_exiting_entry()
  virtual RTC::ReturnCode_t onFinalize();

  // The activated action (Active state entry action)
  // former rtc_active_entry()
  virtual RTC::ReturnCode_t onActivated(RTC::UniqueId ec_id);

  // The deactivated action (Active state exit action)
  // former rtc_active_exit()
  virtual RTC::ReturnCode_t onDeactivated(RTC::UniqueId ec_id);

  // The execution action that is invoked periodically
  // former rtc_active_do()
  virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

 protected:
  // <rtc-template block="protected_attribute">
  
  // </rtc-template>

  // <rtc-template block="protected_operation">
  
  // </rtc-template>


  // DataInPort declaration
  // <rtc-template block="inport_declare">
  TimedCharSeq m_ClueData;
  InPort<TimedCharSeq> m_ClueDataIn;
  
  // </rtc-template>


  // DataOutPort declaration
  // <rtc-template block="outport_declare">
  TimedShortSeq m_PositionData;
  OutPort<TimedShortSeq> m_PositionDataOut;
  TimedCharSeq m_CodeData;
  OutPort<TimedCharSeq> m_CodeDataOut;
  
  // </rtc-template>

  // CORBA Port declaration
  // <rtc-template block="corbaport_declare">
  
  // </rtc-template>

  // Service declaration
  // <rtc-template block="service_declare">
  
  // </rtc-template>

  // Consumer declaration
  // <rtc-template block="consumer_declare">
  
  // </rtc-template>

 private:
  int dummy;
  // <rtc-template block="private_attribute">
  int attribute_1;
  int attribute_2;
  int attribute_3;
  char TempData[1024];
  // </rtc-template>

  // <rtc-template block="private_operation">
  
  // </rtc-template>

};


extern "C"
{
  void ClueAnalyzerInit(RTC::Manager* manager);
};

#endif // CLUEANALYZER_H
