// -*- C++ -*-
/*!
 * @file  PositionViewer.cpp
 * @brief PositionViewer
 * @date $Date$
 *
 * $Id$
 */

#include "PositionViewer.h"

// Module specification
// <rtc-template block="module_spec">
static const char* positionviewer_spec[] =
  {
    "implementation_id", "PositionViewer",
    "type_name",         "PositionViewer",
    "description",       "PositionViewer",
    "version",           "1.0.0",
    "vendor",            "Kenichi Ohara,AIST",
    "category",          "RTMContest",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables
    "conf.default.Size", "0",

    ""
  };
// </rtc-template>

PositionViewer::PositionViewer(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_PositionInformationIn("PositionInformation", m_PositionInformation),
    
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  registerInPort("PositionInformation", m_PositionInformationIn);
  
  // Set OutPort buffer
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

PositionViewer::~PositionViewer()
{
}



RTC::ReturnCode_t PositionViewer::onInitialize()
{
  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  bindParameter("Size", m_Size, "0");
  
  // </rtc-template>
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t PositionViewer::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t PositionViewer::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t PositionViewer::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t PositionViewer::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t PositionViewer::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t PositionViewer::onExecute(RTC::UniqueId ec_id)
{
	//If InPort data is update...
	if(m_PositionInformationIn.isNew()){
		m_PositionInformationIn.read();
		//Check InPort data length
		long length = m_PositionInformation.data.length();

		//Clear temporary memory
		for(int i(0);i<1024;++i){
			PosiTemp[i] = 0;
		}
		//Copy InPort data to temporary memory
		for(int i(0);i<length;++i){
			PosiTemp[i] = m_PositionInformation.data[i];
		}
		
		//Show Position Data and QR Code Size
		std::cout<<"QR Code Size:"<<m_Size<<"[mm]"<<std::endl;
		std::cout<<"Point A: ("<<PosiTemp[0]<<","<<PosiTemp[1]<<")"<<std::endl;
		std::cout<<"Point B: ("<<PosiTemp[2]<<","<<PosiTemp[3]<<")"<<std::endl;
		std::cout<<"Point C: ("<<PosiTemp[4]<<","<<PosiTemp[5]<<")"<<std::endl;
		std::cout<<"Point D: ("<<PosiTemp[6]<<","<<PosiTemp[7]<<")"<<std::endl;
		std::cout<<std::endl;
		delete [] PosiTemp;
	}

  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t PositionViewer::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t PositionViewer::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t PositionViewer::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t PositionViewer::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t PositionViewer::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void PositionViewerInit(RTC::Manager* manager)
  {
    RTC::Properties profile(positionviewer_spec);
    manager->registerFactory(profile,
                             RTC::Create<PositionViewer>,
                             RTC::Delete<PositionViewer>);
  }
  
};


