// -*- C++ -*-
/*!
 * @file  QRCodeViewer.cpp
 * @brief QRCodeInformation
 * @date $Date$
 *
 * $Id$
 */

#include "QRCodeViewer.h"

// Module specification
// <rtc-template block="module_spec">
static const char* qrcodeviewer_spec[] =
  {
    "implementation_id", "QRCodeViewer",
    "type_name",         "QRCodeViewer",
    "description",       "QRCodeInformation",
    "version",           "1.0.0",
    "vendor",            "Kenichi Ohara,AIST",
    "category",          "RTMContest",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

QRCodeViewer::QRCodeViewer(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_CodeDataIn("CodeData", m_CodeData),
    
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  registerInPort("CodeData", m_CodeDataIn);
  
  // Set OutPort buffer
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

QRCodeViewer::~QRCodeViewer()
{
}


/*
RTC::ReturnCode_t QRCodeViewer::onInitialize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t QRCodeViewer::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t QRCodeViewer::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t QRCodeViewer::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t QRCodeViewer::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t QRCodeViewer::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t QRCodeViewer::onExecute(RTC::UniqueId ec_id)
{
	//If connected OutPort is update...
	if(m_CodeDataIn.isNew()){
		m_CodeDataIn.read();
		
		//Check InPort data length
		long length = m_CodeData.data.length();

		//Clear temporary memory
		memset(CodeTemp,0,1024);

		//Copy InPort data to temporary memory
		for(int i(0);i<length;++i){
			CodeTemp[i] = m_CodeData.data[i];
		}
		
		//Show code data
		std::cout<<"Code Data:"<<CodeTemp<<std::endl;
	}
  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t QRCodeViewer::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t QRCodeViewer::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t QRCodeViewer::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t QRCodeViewer::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t QRCodeViewer::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void QRCodeViewerInit(RTC::Manager* manager)
  {
    RTC::Properties profile(qrcodeviewer_spec);
    manager->registerFactory(profile,
                             RTC::Create<QRCodeViewer>,
                             RTC::Delete<QRCodeViewer>);
  }
  
};


